﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace YieldReturn
{
    class StringEnumerator : IEnumerator<string>
    {
        int Counter = -1;

        ConsoleColor[] Colors = new ConsoleColor[] { ConsoleColor.Red, ConsoleColor.Green, ConsoleColor.Blue };

        public string Current
        {
            get
            {
                return ("Color:" + Colors[Counter].ToString());
            }
        }

        Object IEnumerator.Current
        {
            get
            {
                return Current;
            }
        }

        public void Dispose()
        {
            Console.WriteLine("Disposed.");
        }

        public Boolean MoveNext()
        {
            Counter++;

            return (Counter < Colors.Length);
        }

        public void Reset()
        {
            throw new NotSupportedException();
        }
    }
}
